C  ********************************
C  ********************************
C  ***   UNTERPROGRAMM BALK3    ***
C  ********************************
C  ********************************
C  DAS UNTERPROGRAMM BALK 3  ERSTELLT DIE
C  ES - MATRIX FUER DAS STRUKTURELEMENT
C  RAEUMLICHER BALKEN
C****************************************************
C*                                                  *
C*   VERWENDETE VARIABLEN                           *
C*                                                  *
C*   E      : ELASTIZITAETSMODUL                    *
C*   AR     : QUERSCHNITTSFLAECHE                   *
C*   Q      : QUERKONTRAKTION                       *
C*   TRZ;TRY: FLAECHENTRAEGHEITSMOMENTE BEZUEGLICH  *
C*            DER LOKALEN ACHSEN                    *
C*   TRTO   : TORSIONSTRAEGHEITSMOMENT              *
C*   BL     : LAENGE DES ELEMENTES                  *
C*   XL-ZL  : KOORDINATENDIFFERENZEN                *
C*                                                  *
C*   VERWENDETE FELDER                              *
C*                                                  *
C*   X      : KNOTENKOORDINATEN                     *
C*   D      : TRANSFORMATIONSMATRIX D3              *
C*   DL     : TEILE DER LOKALEN ES-MATRIX           *
C*   ELST   : ES-MATRIX                             *
C****************************************************
      SUBROUTINE  BALK3  (X,E,AR,Q,TRZ,TRY,TRTO)
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER             FREI, ANZA
      DIMENSION           X(3,3),D(3,3),DL(3)
C
      COMMON  /ES/   ELST (12,12)
      COMMON  /PAR/  KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *               LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
C
C        KOORDINATENDIFFERENZEN
C
      XL = X(2,1)-X(1,1)
      YL = X(2,2)-X(1,2)
      ZL = X(2,3)-X(1,3)
C
C        BALKENLAENGE
C
      BL = (XL**2+YL**2+ZL**2)**0.5
C
      D(1,1) = XL/BL
      D(1,2) = YL/BL
      D(1,3) = ZL/BL
C
      BLS = (D(1,1)**2+D(1,2)**2)**0.5
C
C         SONDERFALL BALKEN IN Z-RICHTUNG
C
      IF (BLS.NE.0.) GOTO 10
      D(2,1) = 0.
      D(2,2) = 1.
      GOTO 20
10    D(2,1) =-D(1,2)/BLS
      D(2,2) = D(1,1)/BLS
20    D(2,3) = 0.
      D(3,1) = D(1,2)*D(2,3)-D(1,3)*D(2,2)
      D(3,2) = D(1,3)*D(2,1)-D(2,3)*D(1,1)
      D(3,3) = D(1,1)*D(2,2)-D(1,2)*D(2,1)
C
C         ES-MATRIX AUF 0 SETZEN
C
      DO  30  J= 1,12
      DO  30  K= 1,12
30    ELST(J,K)    =0.
C
C         BERECHNUNG DER (3,3)-UNTERMATRIZEN
C         DER GLOBALEN ES-MATRIX
C
      EL=E/BL**2
      DL(1)=E*AR/BL
      DL(2)=12.*EL*TRZ/BL
      DL(3)=12.*EL*TRY/BL
C
      DO  40  K=1,3
      DO  40  L=1,3
      DO  39  M=1,3
39    ELST(K,L)  = ELST(K,L)+D(M,K)*D(M,L)*DL(M)
      ELST(K+6,L+6) = ELST(K,L)
40    ELST(K,L+6)   =-ELST(K,L)
C
      GL=E/(2*(1+Q))
      DL(1)=GL*TRTO/BL
      DL(2)=4.*EL*TRY*BL
      DL(3)=4.*EL*TRZ*BL
C
      DO  50  K=4,6
      DO  50  L=4,6
      DO  49  M=1,3
49    ELST(K,L)  = ELST(K,L)+D(M,K-3)*D(M,L-3)*DL(M)
50    ELST(K+6,L+6) = ELST(K,L)
C
      DL(1)=-DL(1)
      DL(2)= DL(2)/2.
      DL(3)= DL(3)/2.
C
      DO  60  K=4,6
      DO  60  L=10,12
      DO  60  M=1,3
60    ELST(K,L) = ELST(K,L)+D(M,K-3)*D(M,L-9)*DL(M)
C
      DL(2)=-6.*EL*TRY
      DL(3)= 6.*EL*TRZ
C
      DO  70  K=1,3
      DO  70  L=4,6
      ELST(K,L) = ELST(K,L)+D(3,K)*D(2,L-3)*DL(2)
     *                     +D(2,K)*D(3,L-3)*DL(3)
      ELST(K,L+6)   = ELST(K,L)
      ELST(L,K+6)   =-ELST(K,L)
70    ELST(K+6,L+6) =-ELST(K,L)
C
      RETURN
      END
