C    *********************************
C    *********************************
C    ***   UNTERPROGRAMM DREI ********
C    *********************************
C    *********************************
C    DAS UNTERPROGRAMM DREIECK ERSTELLT DIE
C    ES-MATRIX FUER DAS STRUKTURELEMENT DREIECK
C    ************************************************
C    *  VERWENDETE VARIABLEN                        *
C    *                                              *
C    *  E     : ELASTIZITAETSMODUL                  *
C    *  Q     : QUERKONTRAKTION                     *
C    *  DI    : DICKE DES DREIECKELEMENTES          *
C    *  AR    : FLAECHENINHALT DES DREIECKELEMENTES *
C    *  DA-DJ : KOORDINATENDIFFERENZEN              *
C    *                                              *
C    *  VERWENDETE FELDER                           *
C    *                                              *
C    *  X     :KNOTENKOORDINATEN                    *
C    *  ELST  :ES-MATRIX                            *
C    ************************************************
      SUBROUTINE DREI (X,DI,E,Q)
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER  FREI,ANZA
      DIMENSION  X(3,3)
      COMMON  /ES/  ELST(12,12)
      COMMON  /PAR/ KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *              LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
      F = (1.-Q)/2.
C
      DA = X(3,2)-X(2,2)
      DB = X(3,1)-X(2,1)
      DC = X(1,2)-X(3,2)
      DD = X(1,1)-X(3,1)
      DE = X(2,2)-X(1,2)
      DF = X(2,1)-X(1,1)
      DG = F*DB
      DH = F*DA
      DJ = F*DC
C
C         BESTIMMUNG DES FLAECHENINHALTES
C
      AR = 0.5*DABS (DF*DA - DB*DE)
C
C         BESTIMMUNG DES SKALARS G
C
      G = (E*DI)/(4.*AR*(1.-Q**2))
C
C         BERECHNUNG DER RECHTEN TEILMATRIX
C
      ELST(1,1) = (DA**2+DG*DB)*G
      ELST(1,2) = -DB*DA*(Q+F)*G
      ELST(1,3) = (DC*DA+DD*DG)*G
      ELST(1,4) = (-Q*DD*DA-DC*DG)*G
      ELST(1,5) = (DA*DE+DG*DF)*G
      ELST(1,6) = (-Q*DF*DA-DE*DG)*G
      ELST(2,2) = (DB**2+DH*DA)*G
      ELST(2,3) = (-Q*DC*DB-DD*DH)*G
      ELST(2,4) = (DB*DD+DH*DC)*G
      ELST(2,5) = (-Q*DE*DB-DF*DH)*G
      ELST(2,6) = (DB*DF+DH*DE)*G
      ELST(3,3) = (DC**2+F*DD**2)*G
      ELST(3,4) = -DD*DC*(Q+F)*G
      ELST(3,5) = (DE*DC+DF*DD*F)*G
      ELST(3,6) = (-Q*DF*DC-F*DE*DD)*G
      ELST(4,4) = (DD**2+DJ*DC)*G
      ELST(4,5) = (-Q*DE*DD-DJ*DF)*G
      ELST(4,6) = (DF*DD+DJ*DE)*G
      ELST(5,5) = (DE**2+F*DF**2)*G
      ELST(5,6) = -DE*DF*(Q+F)*G
      ELST(6,6) = (DF**2+F*DE**2)*G
      RETURN
      END
