C  ***************************
C  ***************************
C  *** UNTERPROGRAMM SPA92 ***
C  ***************************
C  ***************************
C  DAS UNTERPROGRAMM SPA92 ERMITTELT DIE KRAEFTE UND
C  MOMENTE AN EBENEN BALKENELEMENTEN UND DRUCKT SIE
C******************************************************
C*   VERWENDETE VARIABLEN                             *
C*                                                    *
C*   I1     : ELEMENTNUMMER                           *
C*   XL;YL  : ACHSENABSCHNITTE                        *
C*   E      : ELASTIZITAETSMODUL                      *
C*   AR     : QUERSCHNITTSFLAECHE                     *
C*   TRZ    : FLAECHENTRAEGHEITSMOMENT BEZUEGLICH     *
C*            DER LOKALEN Z-ACHSE                     *
C*   CA;SA  : RICHTUNGSCOSINUS ZU DEN GLOBALEN ACHSEN *
C*                                                    *
C*   VERWENDETE FELDER                                *
C*                                                    *
C*   X      : KNOTENKOORDINATEN                       *
C*   FV     : MATRIZENPRODUKT                         *
C*   F      : KRAFTVEKTOR                             *
C*   I4     : BETEILIGTE KNOTENNUMMERN                *
C******************************************************
      SUBROUTINE SPA92 (I1,I4,X,E,AR,TRZ)
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER          FREI, ANZA
      DIMENSION   X(3,3),FV(3,6),F(6),I4(3)
      COMMON /FELD/ A(110),D(6105),V(500),XKN(500)
      COMMON /PAR/  KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *              LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
C          INITIALISIEREN DES KRAFTVEKTORS
C
      DO   5  J= 1,6
5     F(J) = 0.
C
C        KOORDINATENDIFFERENZEN UND RICHTUNGSCOSINUS
C
      XL = X(2,1) - X(1,1)
      YL = X(2,2) - X(1,2)
      STL= (XL**2+YL**2)**0.5
      CA = XL/STL
      SA = YL/STL
C
C        SKALARE AUS DER LOKALEN ES-MATRIX
C
      FO = E*TRZ/STL**3
      A11= E*AR/STL
      A22=12.*FO
C
C        MATRIZENPRODUKT AUS TRANSFORMATIONSMATRIX
C        UND LOKALER ES-MATRIX
C
      FV(1,1) = CA*A11
      FV(1,4) =-FV(1,1)
      FV(1,2) = SA*A11
      FV(1,5) =-FV(1,2)
      FV(1,3) = 0.
      FV(1,6) = 0.
      FV(2,1) =-SA*A22
      FV(2,4) =-FV(2,1)
      FV(2,2) = CA*A22
      FV(2,5) =-FV(2,2)
      FV(2,3) = 6.*STL*FO
      FV(2,6) = FV(2,3)
      FV(3,1) =-SA*FV(2,3)
      FV(3,4) =-FV(3,1)
      FV(3,2) = CA*FV(2,3)
      FV(3,5) =-FV(3,2)
      FV(3,3) = 4.*FO*STL**2
      FV(3,6) = FV(3,3)/2.
C
C        ERMITTLUNG DES KRAFTVEKTORS
C
      DO  10  J = 1,3
      DO  10  I = 1,2
      DO  10  K = 1,3
      J1 = (I4(I)-1)*FREI+K
      J2 = (I-1)*FREI+K
10    F(J) = F(J) + V(J1)*FV(J,J2)
C
      F(4) =-F(1)
      F(5) =-F(2)
      F(6) = F(3) - (FV(3,3)*V((I4(1)-1)*FREI+3)
     *            +  FV(3,6)*V((I4(2)-1)*FREI+3))
     *            + (FV(3,3)*V((I4(2)-1)*FREI+3)
     *            +  FV(3,6)*V((I4(1)-1)*FREI+3))
C
      WRITE (6,1) I1,I4(1),F(1),F(2),F(3),I4(2),
     *                     F(4),F(5),F(6)
1     FORMAT (1H ,3X,I5,2(3X,I5,3X,'FLAENGS= ',E11.5,
     *        3X,'FQUER= ',E11.5,3X,'MBZ=  ',E11.5/9X))
      RETURN
      END
