C  ********************************
C  ********************************
C  ***   UNTERPROGRAMM STAB  ******
C  ********************************
C  ********************************
C  DAS UNTERPROGRAMM STAB ERSTELLT DIE
C  ES-MATRIX FUER DAS STRUKTURELEMENT STAB
C**************************************************
C*  DX    : DIFFERENZ DER X-KOORDINATEN           *
C*  DY    : DIFFERENZ DER Y-KOORDINATEN           *
C*  DZ    : DIFFERENZ DER Z-KOORDINATEN           *
C*  G     : E*AR/STL                              *
C*  E     : ELASTIZITAETSMODUL DES STABMATERIALS  *
C*  AR    : QUERSCHNITTSFLAECHE DES STABES        *
C*  STL   : LAENGE DES STABES                     *
C*  CALPHA: RICHTUNGSCOSINUS DES STABES           *
C*          AUF DIE X-ACHSE                       *
C*  CBETA : RICHTUNGSCOSINUS DES STABES           *
C*          AUF DIE Y-ACHSE                       *
C*  CGAMMA: RICHTUNGSCOSINUS DES STABES           *
C*          AUF DIE Z-ACHSE                       *
C*                                                *
C*  VERWENDETE FELDER                             *
C*                                                *
C*  X     : KNOTENKOORDINATEN DES STABES,         *
C*  ELST  : ES-MATRIX                             *
C**************************************************
      SUBROUTINE  STAB (X,E,AR)
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER  FREI , ANZA
      DIMENSION    X(3,3)
C
      COMMON  /ES/   ELST(12,12)
      COMMON  /PAR/  KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *               LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
      DZ = 0.
      CGAMMA = 0.
      DX = X(2,1) - X(1,1)
      DY = X(2,2) - X(1,2)
      IF (FREI .EQ. 3) DZ = X(2,3) - X(1,3)
C
C          BESTIMMUNG DER STABLAENGE
C
      STL = (DX**2 + DY**2 + DZ**2)**0.5
C
C          BESTIMMUNG DER RICHTUNGSCOSINUS
C
      CALPHA = DX/STL
      CBETA = DY/STL
      IF (FREI .EQ. 3) CGAMMA = DZ/STL
C
C          BERECHNUNG DES SKALARS G
C
      G = AR*E/STL
C
C         BERECHNUNG DER RECHTEN TEILMATRIX,
C         ELEMENTE FUER DIE 2D- UND 3D-MATRIX
C
      ELST(1,1) = G*CALPHA**2
      ELST(1,2) = G*CALPHA*CBETA
      ELST(2,2) = G*CBETA**2
C
C
C         ELEMENTE FUER DIE 3D-MATRIX
C
      IF (FREI .EQ. 2) GOTO 100
      ELST(1,3) = G*CALPHA*CGAMMA
      ELST(1,4) = - ELST(1,1)
      ELST(1,5) = - ELST(1,2)
      ELST(1,6) = - ELST(1,3)
C
      ELST(2,3) = G*CBETA*CGAMMA
      ELST(2,4) = - ELST(1,2)
      ELST(2,5) = - ELST(2,2)
      ELST(2,6) = - ELST(2,3)
C
      ELST(3,3) = G*CGAMMA**2
      ELST(3,4) = - ELST(1,3)
      ELST(3,5) = - ELST(2,3)
      ELST(3,6) = - ELST(3,3)
C
      ELST(4,4) = ELST(1,1)
      ELST(4,5) = ELST(1,2)
      ELST(4,6) = ELST(1,3)
C
      ELST(5,5) = ELST(2,2)
      ELST(5,6) = ELST(2,3)
C
      ELST(6,6) = ELST(3,3)
C
      RETURN
C
C         ELEMENTE FUER DIE 2D-MATRIX
C
100   ELST(1,3) = - ELST(1,1)
      ELST(1,4) = - ELST(1,2)
C
      ELST(2,3) = - ELST(1,2)
      ELST(2,4) = - ELST(2,2)
C
      ELST(3,3) = ELST(1,1)
      ELST(3,4) = ELST(1,2)
C
      ELST(4,4) = ELST(2,2)
      RETURN
      END
